package org.jeecg.modules.stm.rectify.exec.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rectify.exec.entity.StRectifyExec;
import org.jeecg.modules.stm.rectify.exec.service.IStRectifyExecService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 整改审核
 * @Author: jeecg-boot
 * @Date:   2023-07-21
 * @Version: V1.0
 */

@RestController
@RequestMapping("/rectify.Exec/stRectifyExec")
@Slf4j
public class StRectifyExecController extends JeecgController<StRectifyExec, IStRectifyExecService> {
	@Autowired
	private IStRectifyExecService stRectifyExecService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stRectifyExec
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "整改审核-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StRectifyExec>> queryPageList(StRectifyExec stRectifyExec,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StRectifyExec> queryWrapper = QueryGenerator.initQueryWrapper(stRectifyExec, req.getParameterMap());
		Page<StRectifyExec> page = new Page<StRectifyExec>(pageNo, pageSize);
		IPage<StRectifyExec> pageList = stRectifyExecService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stRectifyExec
	 * @return
	 */
	@AutoLog(value = "整改审核-添加")
	  
	@RequiresPermissions("rectify.Exec:st_rectify_Exec:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StRectifyExec stRectifyExec) {
		stRectifyExecService.save(stRectifyExec);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stRectifyExec
	 * @return
	 */
	@AutoLog(value = "整改审核-编辑")
	  
	@RequiresPermissions("rectify.Exec:st_rectify_Exec:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StRectifyExec stRectifyExec) {
		stRectifyExecService.updateById(stRectifyExec);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "整改审核-通过id删除")
	  
	@RequiresPermissions("rectify.Exec:st_rectify_Exec:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stRectifyExecService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "整改审核-批量删除")
	  
	@RequiresPermissions("rectify.Exec:st_rectify_Exec:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stRectifyExecService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "整改审核-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StRectifyExec> queryById(@RequestParam(name="id",required=true) String id) {
		StRectifyExec stRectifyExec = stRectifyExecService.getById(id);
		if(stRectifyExec==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stRectifyExec);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stRectifyExec
    */
    @RequiresPermissions("rectify.Exec:st_rectify_Exec:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StRectifyExec stRectifyExec) {
        return super.exportXls(request, stRectifyExec, StRectifyExec.class, "整改审核");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("rectify.Exec:st_rectify_Exec:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StRectifyExec.class);
    }

}
